package net.mcreator.musicallyfantastic.client.gui;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.musicallyfantastic.world.inventory.MusicdiscgiverMenu;
import net.mcreator.musicallyfantastic.network.MusicdiscgiverButtonMessage;
import net.mcreator.musicallyfantastic.MusicallyFantasticMod;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class MusicdiscgiverScreen extends AbstractContainerScreen<MusicdiscgiverMenu> {
	private final static HashMap<String, Object> guistate = MusicdiscgiverMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Button button_holding_on_mlg;
	Button button_music_disc_2;
	Button button_music_disc_3;
	Button button_music_disc_4;
	Button button_music_disc_5;
	Button button_music_disc_1;

	public MusicdiscgiverScreen(MusicdiscgiverMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 400;
		this.imageHeight = 200;
	}

	private static final ResourceLocation texture = new ResourceLocation("musically_fantastic:textures/screens/musicdiscgiver.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	public void containerTick() {
		super.containerTick();
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.musically_fantastic.musicdiscgiver.label_music_library"), 10, 177, -12829636, false);
	}

	@Override
	public void onClose() {
		super.onClose();
	}

	@Override
	public void init() {
		super.init();
		button_holding_on_mlg = Button.builder(Component.translatable("gui.musically_fantastic.musicdiscgiver.button_holding_on_mlg"), e -> {
			if (true) {
				MusicallyFantasticMod.PACKET_HANDLER.sendToServer(new MusicdiscgiverButtonMessage(0, x, y, z));
				MusicdiscgiverButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 291, this.topPos + 172, 98, 20).build();
		guistate.put("button:button_holding_on_mlg", button_holding_on_mlg);
		this.addRenderableWidget(button_holding_on_mlg);
		button_music_disc_2 = Button.builder(Component.translatable("gui.musically_fantastic.musicdiscgiver.button_music_disc_2"), e -> {
			if (true) {
				MusicallyFantasticMod.PACKET_HANDLER.sendToServer(new MusicdiscgiverButtonMessage(1, x, y, z));
				MusicdiscgiverButtonMessage.handleButtonAction(entity, 1, x, y, z);
			}
		}).bounds(this.leftPos + 105, this.topPos + 12, 87, 20).build();
		guistate.put("button:button_music_disc_2", button_music_disc_2);
		this.addRenderableWidget(button_music_disc_2);
		button_music_disc_3 = Button.builder(Component.translatable("gui.musically_fantastic.musicdiscgiver.button_music_disc_3"), e -> {
			if (true) {
				MusicallyFantasticMod.PACKET_HANDLER.sendToServer(new MusicdiscgiverButtonMessage(2, x, y, z));
				MusicdiscgiverButtonMessage.handleButtonAction(entity, 2, x, y, z);
			}
		}).bounds(this.leftPos + 201, this.topPos + 12, 87, 20).build();
		guistate.put("button:button_music_disc_3", button_music_disc_3);
		this.addRenderableWidget(button_music_disc_3);
		button_music_disc_4 = Button.builder(Component.translatable("gui.musically_fantastic.musicdiscgiver.button_music_disc_4"), e -> {
			if (true) {
				MusicallyFantasticMod.PACKET_HANDLER.sendToServer(new MusicdiscgiverButtonMessage(3, x, y, z));
				MusicdiscgiverButtonMessage.handleButtonAction(entity, 3, x, y, z);
			}
		}).bounds(this.leftPos + 298, this.topPos + 12, 87, 20).build();
		guistate.put("button:button_music_disc_4", button_music_disc_4);
		this.addRenderableWidget(button_music_disc_4);
		button_music_disc_5 = Button.builder(Component.translatable("gui.musically_fantastic.musicdiscgiver.button_music_disc_5"), e -> {
			if (true) {
				MusicallyFantasticMod.PACKET_HANDLER.sendToServer(new MusicdiscgiverButtonMessage(4, x, y, z));
				MusicdiscgiverButtonMessage.handleButtonAction(entity, 4, x, y, z);
			}
		}).bounds(this.leftPos + 10, this.topPos + 36, 87, 20).build();
		guistate.put("button:button_music_disc_5", button_music_disc_5);
		this.addRenderableWidget(button_music_disc_5);
		button_music_disc_1 = Button.builder(Component.translatable("gui.musically_fantastic.musicdiscgiver.button_music_disc_1"), e -> {
			if (true) {
				MusicallyFantasticMod.PACKET_HANDLER.sendToServer(new MusicdiscgiverButtonMessage(5, x, y, z));
				MusicdiscgiverButtonMessage.handleButtonAction(entity, 5, x, y, z);
			}
		}).bounds(this.leftPos + 10, this.topPos + 12, 87, 20).build();
		guistate.put("button:button_music_disc_1", button_music_disc_1);
		this.addRenderableWidget(button_music_disc_1);
	}
}
