
package net.mcreator.musicallyfantastic.network;

import net.minecraftforge.network.NetworkEvent;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.core.BlockPos;

import net.mcreator.musicallyfantastic.world.inventory.MusicdiscgiverMenu;
import net.mcreator.musicallyfantastic.procedures.DsszfxcdrxtrxttdtrgtfvProcedure;
import net.mcreator.musicallyfantastic.procedures.Discgive5Procedure;
import net.mcreator.musicallyfantastic.procedures.Discgive4Procedure;
import net.mcreator.musicallyfantastic.procedures.Discgive3Procedure;
import net.mcreator.musicallyfantastic.procedures.Discgive2Procedure;
import net.mcreator.musicallyfantastic.procedures.Discgive1Procedure;
import net.mcreator.musicallyfantastic.MusicallyFantasticMod;

import java.util.function.Supplier;
import java.util.HashMap;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public class MusicdiscgiverButtonMessage {
	private final int buttonID, x, y, z;

	public MusicdiscgiverButtonMessage(FriendlyByteBuf buffer) {
		this.buttonID = buffer.readInt();
		this.x = buffer.readInt();
		this.y = buffer.readInt();
		this.z = buffer.readInt();
	}

	public MusicdiscgiverButtonMessage(int buttonID, int x, int y, int z) {
		this.buttonID = buttonID;
		this.x = x;
		this.y = y;
		this.z = z;
	}

	public static void buffer(MusicdiscgiverButtonMessage message, FriendlyByteBuf buffer) {
		buffer.writeInt(message.buttonID);
		buffer.writeInt(message.x);
		buffer.writeInt(message.y);
		buffer.writeInt(message.z);
	}

	public static void handler(MusicdiscgiverButtonMessage message, Supplier<NetworkEvent.Context> contextSupplier) {
		NetworkEvent.Context context = contextSupplier.get();
		context.enqueueWork(() -> {
			Player entity = context.getSender();
			int buttonID = message.buttonID;
			int x = message.x;
			int y = message.y;
			int z = message.z;
			handleButtonAction(entity, buttonID, x, y, z);
		});
		context.setPacketHandled(true);
	}

	public static void handleButtonAction(Player entity, int buttonID, int x, int y, int z) {
		Level world = entity.level();
		HashMap guistate = MusicdiscgiverMenu.guistate;
		// security measure to prevent arbitrary chunk generation
		if (!world.hasChunkAt(new BlockPos(x, y, z)))
			return;
		if (buttonID == 0) {

			DsszfxcdrxtrxttdtrgtfvProcedure.execute(entity);
		}
		if (buttonID == 1) {

			Discgive2Procedure.execute(entity);
		}
		if (buttonID == 2) {

			Discgive3Procedure.execute(entity);
		}
		if (buttonID == 3) {

			Discgive4Procedure.execute(entity);
		}
		if (buttonID == 4) {

			Discgive5Procedure.execute(entity);
		}
		if (buttonID == 5) {

			Discgive1Procedure.execute(entity);
		}
	}

	@SubscribeEvent
	public static void registerMessage(FMLCommonSetupEvent event) {
		MusicallyFantasticMod.addNetworkMessage(MusicdiscgiverButtonMessage.class, MusicdiscgiverButtonMessage::buffer, MusicdiscgiverButtonMessage::new, MusicdiscgiverButtonMessage::handler);
	}
}
